/* DELTREE.CMD  R.J.Holmgren 11/29/01
Delete all [sub]directories & files starting in specified directory */

rxutl=0
signal on Halt
parse arg dr
dr=strip(dr)
do while left(dr,1)='"'
  dr=substr(dr,2)
  end
a='"\*. '
if left(dr,1)='.' then do
  if right(directory(),1)\='\' then dr='\'||dr
  dr=directory()||dr
  end
do until c=0
  c=0
  do b=1 to 5
    if dr=''|dr='-?'|dr='/?' then call Help
    if right(dr,1)=substr(a,b,1) then do
      dr=left(dr,length(dr)-1)
      c=1
      end
    end
  end
if dr=''|dr='-?'|dr='/?' then call Help
rxutl=RxFuncQuery("SysLoadFuncs")
if rxutl then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end
call SysFileTree dr,"dir","D"
if dir.0=0 then do
  say 'ERROR: Directory "'dr'" not found'
  call Help
  end
d=dr
dd=0
df=0
fd=0
ff=0
bytes=0
'@echo off'
do until d=dr
  dr=d
  call Main
  end
say
if fd+ff>0 then do
  call Charout,fd+ff 'ERROR'
  if fd+ff>1 then call Charout,'S'
  say '!'
  end
else say 'No Errors'
say
say 'Deleted Files: 'df'  ('bytes' bytes)'
say 'Deleted Directories:' dd
if fd+ff>0 then do
  say 'Errors deleting files:' ff
  say 'Errors deleting directories:' fd
  end
say
Halt:
if rxutl then call SysDropFuncs
exit

MAIN:
do until dir.0=0
  call SysFileTree dr||"\*","dir","DO"
  if dir.0>0 then do
    dr=dir.1
    end
  end
call SysFileTree dr||"\*","fil","FO"
if fil.0>0 then do i=1 to fil.0
  call SysFileTree fil.i,'fl','F',,'-----'
  rc=SysFileDelete(fil.i)
  if rc=0 then do
    say 'Deleted F' fil.i
    df=df+1
    bytes=bytes+subword(fl.1,3,1)
    end
  else do
    say 'Error deleting file' fil.i': return code='rc
    ff=ff+1
    end
  end
call SysFileTree dr,'dl','D',,'-----'
'rd "'dr'"'
if rc=0 then do
  say 'Deleted D' dr
  dd=dd+1
  end
else do
  say 'Error deleting directory' dr': return code='rc
  fd=fd+1
  end
RETURN

HELP:
  say
  say 'DELTREE.CMD for Win32|OS/2  RJH 11/29/01 Requires IBM [Object] Rexx'
  say 'Delete all [sub]directories & files starting in specified directory'
  say
  say 'Syntax: [REXX.EXE] DELTREE.CMD directory_to_delete'
  say '   e.g. REXX.EXE DELTREE.CMD c:\new\my trash heap'
  say '        DELTREE .'
  say
  say 'Note Well:  DELTREE is a DANGEROUS command! Deletions proceed without'
  say 'confirmation. Read-Only|Hidden|System files and dirs ARE deleted!'
  say 'Ctrl-C to Abort (if supported by Operating System)'
  exit
RETURN
