/* XYGREP.CMD  XyGrep for Win32|OS/2  R.J.Holmgren  2000/20/8 LastRev.2002/7/26

XyWrite Usage:
  XYGREP ["]filemask["] ["]search$tring["] [C][N] [YYYY-MM-DD] [b|A]<Helpkey>
  Quotes ("") required if filespec|search$tring contains spaces|wildcards
  Search$tring may contain one or more wildcards of ONE type: ' AND |';' OR |';' NOT |'
    (3-byte "red" chars for XyWrite CMline only)
  C = Case SeNsItIvE; N = cite line Numbers within files
  "YYYY-MM-DD" = Date-limited search;
  "b|A" = only search files before|After [default] date */

rxutl=RxFuncQuery("SysLoadFuncs")
if rxutl then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end
signal on halt name bye
parse arg linein
c=linein||' '
fspec=''
strng=''
opts=''
dat=''
chrs='"= =-'
do until chrs='-'
  char=left(chrs,pos('=',chrs)-1)
  chrs=substr(chrs,pos('=',chrs)+1)
  if pos(char,c)>0 then do until pos(char,c)=0
    a=pos(char,c)
    if a>1 then do
      b=left(c,a-1)
      c=substr(c,a+1)
      if opts=''&strng\=''&(length(b)=1|length(b)=2) then opts=strip(b)
      else do
/*         if strng=''&fspec\='' then strng=strip(b) */
        if strng=''&fspec\='' then strng=b
        else if fspec='' then fspec=strip(b)
        end
      if strng\=''&pos('-',c)>0 then dat=strip(c)
      end
    else c=substr(c,pos(char,c)+1)
    end
  end
dy='';dm='';dd='';ba=''
if length(dat)>9 then do
  parse var dat dy'-'dm'-'dd' 'ba
  dy=strip(dy)
  dm=strip(dm)
  dd=strip(dd)
  ba=translate(strip(ba))
  if ba\='B' then ba='A'
  if length(dy)\=4|length(dm)\=2|length(dd)\=2|verify(dy,'0123456789')>0|verify(dm,'0123456789')>0|verify(dd,'0123456789')>0 then do
    say 'Date input error'
    call Bye
    end
  d=dy||dm||dd
  end
strng.1=''
sep=1
seps='FF'x||'= AND ='||'FF'x||'= OR ='||'FF'x||'= NOT =-'
sepns=' AND = AND = OR = OR = NOT = NOT =-'
do until seps='-'|gotit=1
  sepchar=left(seps,pos('=',seps)-1)
  seps=substr(seps,pos('=',seps)+1)
  sepname=left(sepns,pos('=',sepns)-1)
  sepns=substr(sepns,pos('=',sepns)+1)
  strngorg=''
  gotit=0
  do while pos(sepchar,strng)>0
    gotit=1
    if pos(sepchar,strng)>1 then strng.sep=left(strng,pos(sepchar,strng)-1)
    else strng.sep=''
    strngorg=strngorg||strng.sep||sepname
    if pos(sepchar,strng)>1 then sep=sep+1
    strng=substr(strng,pos(sepchar,strng)+length(sepchar))
    end
  strng.sep=strng
  strngorg=strngorg||strng.sep
  end
if sepchar=' NOT '&pos(sepchar,strngorg)=0 then sepchar=''
opts=translate(opts)
if length(fspec)>0&length(strng)>0&fspec\='?'&fspec\='/?'&fspec\='-?'&translate(fspec)\='HELP'&translate(fspec)\='/HELP'&translate(fspec)\='-HELP' then do
  i='Searching for "'||strngorg||'" (case '
  if pos('C',opts)=0 then i=i||'INsensitive'
  else i=i||'SeNsItIvE'
  i=i||') in "'||fspec||'" filemask'
  say i||'...'
  call SysFileTree fspec,'file','OS'
  if file.0>0 then do
    call SysCls
    say i
    say 'Number of "'||fspec||'" specs found:' file.0
    end
  do i=1 to file.0
    if dat\='' then do
      del=0
      call SysFileTree file.i,"fil","FL"
      parse var fil.1 dfy'-'dfm'-'dfd' 'dum
      df=dfy||dfm||dfd
      del=0
      if ba='B'&df<d then del=1
      if ba='A'&d<df then del=1
      end
    else del=1
    if del=1 then do
      foundand=0
      foundor=0
      foundnot=-1;if sepchar='FF'x||''|sepchar=' NOT ' then foundnot=0
      if sepchar\='' then do
        do j=1 to sep
          call SysFileSearch strng.j,file.i,'found.',opts
          if (sepchar='FF'x||''|sepchar=' AND ')&found.0>0 then foundand=foundand+1
          if (sepchar='FF'x||''|sepchar=' OR ')&found.0>0 then foundor=1
          if (sepchar='FF'x||''|sepchar=' NOT ')&found.0\=0 then foundnot=1
          if foundor=1|foundnot=1 then leave
          end
        end
      if foundnot=0 then do
        say file.i
        x=SysCurPos()
        if left(x,pos(' ',x)-1)>=22 then do
          call Charout,'Hit any key to continue...'
          call SysGetKey 'noecho'
          call SysCls
          end
        end
      if foundand=sep|foundor=1|sepchar='' then do k=1 to sep
        call SysFileSearch strng.k,file.i,'found2.',opts
        if found2.0\='FOUND2.0'&found2.0\='0' then do
SAY df
          call Charout,file.i||' - '||found2.0 'match'
          if found2.0>1 then call Charout,'s'
          say ' of "'strng.k'":'
          if found2.0>0 then do y=1 to found2.0
            say ' '||found2.y
            x=SysCurPos()
            if left(x,pos(' ',x)-1)>=22 then do
              call Charout,'Hit any key to continue... ('file.i')'
              call SysGetKey 'noecho'
              call SysCls
              end
            end
          end
        end
      end
    end
  if file.0>0 then do
    call Charout,'Hit any key to quit...'
    call SysGetKey 'noecho'
    say
    end
  say
  end
else do
  say 'XYGREP.CMD  XyGrep  R.J.Holmgren  7/26/2002'
  say 'Recursive search for $trings within files in [sub]directories'
  say 'Search$tring may contain one or more WILDCARDS of ONE type:'
  say ' " AND "|" OR "|" NOT " (note leading/trailing spaces)'
  say 'Options: "C"=Case SeNsItIvE; "N"=display line Number'
  say '         "YYYY-MM-DD"=Date-limited search;'
  say '         "b|A"=only search files before|After [default] date'
  say
  say 'Usages:'
  say '~~~~~~'
  say 'XyWrite: XYGREP file_spec ["]search$["] [C][N] [YYYY-MM-DD] [b|A]<Helpkey>'
  say 'DOS:     [d:\path\]XYGREP[.BAT] file_spec search$ [C][N] [YYYY-MM-DD] [b|A]<cr>'
  say 'OS/2:    [d:\path\]XYGREP[.CMD] file_spec search$ [C][N] [YYYY-MM-DD] [b|A]<cr>'
  say 'Win32:   REXX [d:\path\]XYGREP.CMD file_spec search$ [C][N] [YYYY-MM-DD] [b|A]<cr>'
  say '  e.g.:  xygrep C:\CONFIG.SYS Device N'
  say '         xygrep D:\*.TXT "XyWrite IV" C <==quotes if spaces in argument'
  say '         xygrep D:\*.TXT "XyWrite OR XyWin" CN 2002-04-21 B<==quotes if wildcards in argument'
  say '         xygrep D:\*.TXT " NOT XyWrite NOT forsake"<==space preceding initial "NOT"'
  say '         xygrep D:\*.TXT "XyWrite NOT forsake"<==same as above (all search specs obey wildcard)'
  end
if rxutl then call SysDropFuncs
exit
bye:
if rxutl then call SysDropFuncs
say 'Abort'
exit
