/* MAKEBATS.REX for XyShell Win32  Rexx v1+ or Runtime v2  RJH 2/16/2002 */
if RxFuncQuery("SysLoadFuncs") then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end

/*********USER****VARIABLE:********
  READ THIS MESSAGE CAREFULLY!
  Indicate the Rexx Installation Directory below.  The "Rexx Directory"
    is the dir where REXX.EXE,*.REX,*.CMD,*.BAT,W2-ALIAS.DAT all reside
  Default=[bootdrive:]\PROGRA~1\ObjREXX
  No adjustment necessary if you installed to [BootDrive]:\PROGRA~1\ObjREXX
  This PATH spec is CaSe-SeNsItIvE  Write it EXACTLY as it appears
    in a Windows Explorer directory listing or at an MS-DOS prompt.
    Note the example on the next line, which mixes UPPER and lower
    case characters.
         Set RexxDir on next line, e.g. RexxDir='C:\PROGRA~1\ObjREXX' */
RexxDir=SysBootDrive()||'\PROGRA~1\ObjREXX'
/***********************************/

say
y='0D0A'x
propties=RexxDir||'\SW.BAT'
call Killbats
call stream propties,'C','open write'
x=':: SW.BAT for Win32 [XYSHELL.ZIP]  2/16/2002  R.J.Holmgren'||y||':: Switch from DOS to running Win32 process'||y||':: '||y||'@echo off'||y||RexxDir||'\REXX.EXE '||RexxDir||'\SW.REX %1 %2 %3 %4 %5 %6 %7 %8 %9'||y
call charout propties,x
i=9
do until i=0
  x='for %%a in (c C) do if "%'||i||'"=="/%%a" exit'
  call lineout propties,x
  i=i-1
  end
call lineout propties,':exit'
call stream propties,'C','close'
call Attribs
propties=RexxDir||'\W2.BAT'
call Killbats
call stream propties,'C','open write'
x=':: W2[WIN].BAT for Win32 [XYSHELL.ZIP]  2/16/2002  R.J.Holmgren'||y||':: Start Windows process from XyWrite IV+|NotaBene for Windows'||y||':: '||y||'@echo off'||y||'if "%1"=="" '||RexxDir||'\REXX.EXE '||RexxDir||'\W2.REX'||y||'if "%1"=="" goto ex'||y||'START /MIN '||RexxDir||'\REXX.EXE '||RexxDir||'\W2.REX'||y||':ex'||y||'exit'||y
call charout propties,x
call stream propties,'C','close'
call Attribs
x=stream(RexxDir'\IBMPRO~1.EXE','C','query exists')
if x\='' then call SysFileDelete RexxDir'\IBMPRO~1.EXE'
if pos('NT',SysWinVer())=0&pos('2000',SysWinVer())=0&pos('XP',SysWinVer())=0 then do
  propties=RexxDir||'\W2WIN.BAT'
  call Killbats
  'copy' RexxDir'\W2.BAT' propties
  call Attribs
  winMgr=.WindowsManager~new
  if winMgr~initcode\=0 then exit
  z=''
  subdir=RexxDir
  do until pos('\',subdir)=0
    subdir=substr(subdir,pos('\',subdir)+1)
    end
  do until pos('NIL',i)>0
    i=winMgr~Find(subdir)
    if pos('NIL',i)=0 then do
      i~SendSysCommand("CLOSE")
      call SysSleep 1
      end
    end
  fswin='&Full-screen'
  propties='Sw.bat Properties'
  'explorer.exe /select,'RexxDir'\SW.BAT'
  call Main
  propties='W2.bat Properties'
  'explorer.exe /select,'RexxDir'\W2.BAT'
  call Main
  fswin='&Window'
  propties='W2win.bat Properties'
  'explorer.exe /select,'RexxDir'\W2WIN.BAT'
  call Main
  winMgr~Deinstall
  call SysSwitchSession "Program Manager"
  end
say 'Done'
exit
  
MAIN:
  i=0
  do until pos('NIL',tm)=0|i=3  /* allow max 3secs to find it */
    tm=winMgr~Find(subdir)
    if pos('NIL',tm)>0 then call SysSleep 1
    i=i+1
    end
  if pos('NIL',tm)>0 then do
    propties='Windows Explorer'
    call Abort
    end
  tm~ToForeground
  if pos('Min',tm~State)>0 then tm~Restore
  tm~ProcessMenuCommand("&File","P&roperties")
  i=0
  do until pos('NIL',prop)=0|i=3
    prop=winMgr~Find(propties)
    if pos('NIL',prop)>0 then call SysSleep 1
    i=i+1
    end
  if pos('NIL',prop)>0 then call Abort
  y=prop
  z="General"
  call Try
  propl=x~Last
  call Propll
  prop~ToForeground
  if pos('Min',prop~State)>0 then prop~Restore
  y=prop
  z="Program"
  call Try
  y=x
  z="Close on e&xit"
  call Try
  x~SendKey("ADD")
  call Propll
  propl~SendKey("RIGHT")
  propl~SendKey("RIGHT")
  y=prop
  z="Screen"
  call Try
  y=x
  z=fswin
  call Try
  x~SendKey("SPACE")
  call Propll
  y=prop
  z="Misc"
  call Try
  y=x
  z="Always &suspend"
  call Try
  x~SendKey("SUBTRACT")
  prop~PushButton("&Apply")
  prop~SendSysCommand("CLOSE")
  tm~SendSysCommand("CLOSE")
  say 'Set' propties 'successfully...'
RETURN

TRY:
  i=0
  do until pos('NIL',x)=0|i=3  /* allow max 3secs to find it */
    x=y~FindChild(z)
    if pos('NIL',x)>0 then call SysSleep 1
    i=i+1
    end
  if pos('NIL',x)>0 then call Abort
  x~ToForeground
  if pos('Min',x~State)>0 then x~Restore
RETURN

PROPLL:
  propl~ToForeground
  if pos('Min',propl~State)>0 then propl~Restore
  propl~SendKey("RIGHT")
RETURN

ABORT:
  if z\='' then propties=z||' in '||propties
  say propties 'not found - Aborting'
  winMgr~Deinstall
  exit
RETURN

KILLBATS:
  x=stream(propties,'C','query exists')
  if x\='' then do
    /* Clear All (e.g. Read-Only) attributes of BATs */
    call SysFileTree propties,'file','F','*****','-----'
    if file.0=1 then call SysFileDelete propties
    end
RETURN

ATTRIBS:
  call SysFileTree propties,'file','F','*****','***+*'
  if file.0=1 then say 'Created' propties
RETURN

::requires "WINSYSTM.CLS"   /* access class definitions */

