/* GetMail (POP3) [Object]Rexx XyShell Win32|OS/2  RJH 12/30/02
See GetMail.INI for Usage instructions */

fs=''
parse arg inp
if pos('"',inp)=1 then do
  fs=substr(inp,2,lastpos('"',inp)-2)
  inp=substr(inp,lastpos('"',inp)+2)
  end
if fs='' then do
  parse source . . inp1
  fs=left(inp1,lastpos('\',inp1))||'GETMAIL.INI'
  end
if stream(fs,'C','query exists')\='' then do
  call stream fs,'C','open read'
  do while lines(fs)>0
    vr='[LOGIN]';call Stanza
    vr='POPSERVER';call Spec;pop=vr
    vr='USERNAME';call Spec;user=vr
    vr='PASSWORD';call Spec;pw=vr
    vr='POPPORT';call Spec;pport=vr
    vr='[MAIL]';call Stanza
    vr='WRITESEPARATE';call Spec;writeseparate=vr
    vr='MAILFILE';call Spec;interpret mailfile'='vr
    vr='WRITEAUTO';call Spec;writeauto=vr
    vr='DELETEALL';call Spec;deleteall=vr
    vr='[FILTERS]';call Stanza
    vr='USEFILTERS';call Spec;usefilters=vr
    if usefilters=1&writeseparate=1 then do
      g=0
      do until lines(fs)=0
        g=g+1
        vr='FILTER.'||g;call Spec
        if vr\='' then filter.g=vr
        end
      g=g-1 /* Number of filters defined */
      if g=0 then usefilters=0
      end
    else usefilters=0
    leave
    end
  call stream fs,'C','close'
  end
pop2='';user2='';pw2='';dw=''
parse var inp pop2' 'user2' 'pw2' 'dw
if pop2\=''&user2\=''&pw2\=''&pos('-',pop2)\=1&pos('-',user2)\=1&pos('-',pw2)\=1 then do
  pop=pop2
  user=user2
  pw=pw2
  end
if pop='POP' then call Help
if fs='' then do /* defaults if no INIfile found */
  writeseparate=0
  mailfile=substr(date('S'),4)||'001.POP'
  writeauto=0
  deleteall=0
  usefilters=0
  end
if writeauto\=1 then do
  writeauto=0
  deleteall=0
  end
if pos('-',pop2)=1 then dw=pop2
dw=translate(dw)
if dw='-W'|dw='-WD'|dw='-DW' then do
  writeauto=1
  if pos('D',dw)>1 then deleteall=1
  else deleteall=0
  end
if pop2='/?'|pop2='-?'|pop='?'|pop=''|user=''|pw=''|pport=''|verify(pport,'0123456789')>0 then call Help
if writeseparate\=3 then do
  if mailfile=''|verify(writeseparate,'012')>0|verify(writeauto,'01')>0|verify(deleteall,'01')>0 then call Help
  end
sockdata=''
rxutl=RxFuncQuery("SysLoadFuncs")
if rxutl then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end
rxsck=RxFuncQuery("SockLoadFuncs")
if rxsck then do
  call RxFuncAdd 'SockLoadFuncs','RxSock','SockLoadFuncs'
  call SockLoadFuncs
  call SysCls
  end
signal on Halt
of=0 /* Writefile Open Flag */
bye3rc='SockSocket'
socket=SockSocket('AF_INET','SOCK_STREAM','IPPROTO_TCP')
if socket>-1 then do
  bye3rc='SockGetHost'
  if verify(pop,'.0123456789')>0 then rc=SockGetHostByName(pop,'host.!')
  else rc=SockGetHostByAddr(pop,'host.!')
  if rc=1 then do
    host.!family='AF_INET'
    host.!port=pport
    say 'Fetching mail from' pop 'for' user
    rc=SockConnect(socket,'host.!')
    if rc=0 then do
      cr='0D'x
      lf='0A'x
      crlf='0D0A'x
      bye3rc='USER'
      d=0
      del.d=''
      call SockRecv socket,'sockdata',1024
      say sockdata
      rc=SockSend(socket,'USER 'user||crlf)
      if rc>-1 then do
        rc=SockRecv(socket,'sockdata',1024)
        if pos('+OK',sockdata)=0 then call Bye2
        end
      else call Bye3
      bye3rc='PASS'
      rc=SockSend(socket,'PASS 'pw||crlf)
      if rc>-1 then do
        rc=SockRecv(socket,'sockdata',1024)
        if pos('+OK',sockdata)=0 then call Bye2
        end
      else call Bye3
      bye3rc='STAT'
      do until verify(y,'0123456789')=0
        rc=SockSend(socket,'STAT'||crlf)
        if rc>-1 then do
          rc=SockRecv(socket,'sockdata',1024)
          if pos('+OK',sockdata)=0 then call Bye2
          parse var sockdata ok y size '0D0A'x
          end
        else call Bye3
        end
      if y=0 then do
        say 'You have No new messages'
        call Bye
        end
      y2=0
      remainder=''
      bye3rc='LIST'
      rc=SockSend(socket,'LIST'||crlf)  /* Get msg sizes */
      if rc>-1 then do until lin='.'
        rc=SockRecv(socket,'sockdata',1024)
        sockdata=remainder||sockdata
        if y2=0 then do
          parse var sockdata dummy '0D0A'x remainder
          if pos('+OK',dummy)\=1 then call Bye2
          sockdata=remainder
          end
        do until pos(lf,sockdata)=0
          parse var sockdata lin '0A'x remainder
          ll=length(lin)
          if ll>0&pos(cr,lin)=ll then lin=left(lin,ll-1)
          if lin\='.' then do
            if y2>0&siz.y2='' then nop /* New 10/6/01 */
            else y2=y2+1
            parse var lin dummy siz.y2
            end
          sockdata=remainder
          end
        end
      else call Bye3
      say 'You have' y 'new messages ('size' bytes)'
      bye3rc='TOP'
      do y1=1 to y
        dummy1=y1
        call Checkdel
        if del.d1\=dummy1 then do
          num=0
          say
          say 'Reading header msg 'y1' (of 'y')'
          remainder=''
          rc=SockSend(socket,'TOP '||y1||' 0'||crlf)
          if rc>-1 then do until lin='.'
            rc=SockRecv(socket,'sockdata',1024)
            sockdata=remainder||sockdata
            do until pos(lf,remainder)=0
              parse var sockdata lin '0A'x remainder
              ll=length(lin)
              if ll>0&pos(cr,lin)=ll then lin=left(lin,ll-1)
              if lin\='.' then do
                if num<4 then do
                  linuc=translate(lin)
                  if pos('FROM:',linuc)=1|pos('TO:',linuc)=1|pos('SUBJECT:',linuc)=1|pos('DATE:',linuc)=1 then do
                    say lin
                    num=num+1
                    end
                  end
                end
              sockdata=remainder
              end
            end
          else call Bye3
          say 'Size: 'siz.y1 'bytes'
          call Opts
          end
        end
      end
    else call Bye3
    end
  else call Bye3
  end
Bye:
if of&writeseparate\=1 then call stream mailf,'C','close'
call SockSend socket,'QUIT'||crlf
rc=SockRecv(socket,'sockdata',1024)
say
say 'QUITting: 'sockdata
/* call SockShutDown socket,2 */  /* Bug in Win32 REXX */
call SockClose socket
if rxsck then call SockDropFuncs
if rxutl then call SysDropFuncs
exit

STANZA: /* Parse INIfile */
  do until pos(vr,strip(translate(line)))=1
    line=linein(fs)
    end
RETURN

SPEC:
  do until pos(vr||'=',strip(translate(line)))=1
    line=linein(fs)
    if lines(fs)=0 then do
      vr=''
      RETURN
      end
    end
  vr=strip(substr(line,pos('=',line)+1))
RETURN

OPTS:
  if writeauto&writeseparate\=3 then k='W'
  else do
    call Charout,'(R)ead '
    if writeseparate\=3 then call Charout,'(W)rite to file '
    call Charout,'(D)elete (N)ext (P)revious (J)ump (Q)uit?  R'
    if writeseparate\=3 then call Charout,'W'
    call Charout,'DNPJQ: '
    dum='DJNPQR'
    if writeseparate\=3 then dum=dum||'W'
    do until pos(k,dum)>0
      k=translate(SysGetKey('noecho'))
      end
    say k
    end
OPTS1:
  if k='J' then do
    dummy1=''
    call Charout,'Jump to message number 1-'y': '
    do until pos(dummy,cr)>0
      dummy=SysGetKey('noecho')
      if pos(dummy,cr)=0&pos(dummy,'0123456789')>0 then do
        dummy1=dummy1||dummy
        call Charout,dummy
        end
      end
    say
    if dummy1<1|dummy1>y then call Opts1
    call Checkdel
    if del.d1=dummy1 then call Opts1
    y1=dummy1-1
    end
  if k='P' then do
    y1=y1-1
    dummy1=y1
    call Checkdel
    if y1>0&del.d1\=dummy1 then y1=y1-1
    end
  if k='Q' then do
    call Bye
    end
  if k='W' then do
    mailfn=''
    if usefilters=1 then call Filters
    if k='W' then do
      say
      if writeseparate=1 then call Openfile
      else if of=0 then call Openfile
      say 'Writing msg' y1 'to' mailf
      if writeseparate\=1 then call Charout mailf,'-=-=-=-=-=-= 'left(date('N',,,'-'),length(date('N',,,'-'))-4)||right(date(),2)' 'time('N')' Message ['y1' of 'y'] =-=-=-=-=-=-'crlf
      call Charout,'Bytes written '
      clr=SysCurPos()
      r=pos(' ',clr)
      l=left(clr,r-1)
      r=right(clr,length(clr)-r)
      y3=0
      sd=''
      se=''
      sz=siz.y1
      rc=SockSend(socket,'RETR 'y1||crlf)
      if rc>-1 then do until sz<=0 /* Changed "=" to "<=" 10/3/01 */
        sc=SockRecv(socket,'sockdata',1024)
        if pos(crlf||'.',sockdata)>0 then do
          sf=sockdata
          sockdata=''
          do until pos(crlf||'.',sf)=0
            se=left(sf,pos(crlf||'.',sf)+1)
            sf=substr(sf,pos(crlf||'.',sf)+3)
            sockdata=sockdata||se
            sz=sz+1
            end
          sockdata=sockdata||sf
          end
        if y3=0 then do /* Skip 1st line [server ack] */
          parse var sockdata dummy '0D0A'x remainder
          if pos('+OK',dummy)\=1 then call Bye2
          sz=sz+length(dummy)+4
          sockdata=remainder
          y3=1
          end
        sz=sz-sc
        if sz>0 then do
          if sd\='' then call Charout mailf,sd
          sd=sockdata
          end
        else do
          y3=length(sockdata)
          if y3>1 then y3=y3-1 /* Do it 2x! */
          if y3>1 then y3=y3-1
          sd=sd||left(sockdata,y3)
          end
        call SysCurPos l,r
        call Charout,siz.y1-sz||' ('||trunc((siz.y1-sz)/siz.y1*100)||'% of '||siz.y1||')'
        end
      call Charout mailf,sd
      if writeseparate=1 then do
        call stream mailf,'C','close'
        call Preincrement
        end
      say
      end
    end
  if deleteall then k='D'
  if k='D' then do
    rc=SockSend(socket,'DELE 'y1||crlf)
    if rc>-1 then do
      rc=SockRecv(socket,'sockdata',1024)
      say
      say 'DELEting message 'y1': 'left(sockdata,length(sockdata)-2)
      d=d+1
      del.d=y1
      end
    end
  if k='R' then do
    call SysCls
    say 'Message' y1':'
    lins=0
    rc=SockSend(socket,'RETR 'y1||crlf)
    remainder=''
    readit=1
    sz=-9999
    if rc>-1 then do until sz<=0 /* Changed "=" to "<=" 10/3/01 */
      sc=SockRecv(socket,'sockdata',1024)
      if sz=-9999 then do
        parse var sockdata lin '0A'x dummy
        sz=siz.y1+length(lin)+4
        end
      sz=sz-sc
      sockdata=remainder||sockdata
      do until pos(lf,remainder)=0
        parse var sockdata lin '0A'x remainder
        if pos('.',lin)=1&lin\='.'||cr then do
          if readit then lin=substr(lin,2)
          sz=sz+1
          end
        if readit then do
          ll=length(lin)
          if ll>0&pos(cr,lin)=ll then lin=left(lin,ll-1)
          lins=lins+1+length(lin)%80
          if lins>=23&readit then do
            call Charout,'  '
            if writeseparate\=3 then call Charout,'(W)rite '
            call Charout,'(D)elete (N)ext (P)rev (J)ump (Q)uit (other key continues Reading): '
            dum='DJNPQ'
            if writeseparate\=3 then dum=dum||'W'
            k=translate(SysGetKey('noecho'))
            if pos(k,dum)=0 then do
              lins=length(lin)%80 /* Solution to line overruns */
              k='R'
              call SysCls
              end
            else do
              readit=0
              say k
              end
            end
          if readit then say lin
          end
        sockdata=remainder
        end
      end
    if readit then do
      say 'Reprise message 'y1' (of 'y'):'
      call Opts
      end
    else if k\='N' then call Opts1
    end
RETURN

BYE2:
  say '(Server says "'sockdata'")'
  call Bye
RETURN

BYE3:
  if bye3rc='SockSocket' then say bye3rc ' rc='socket
  else say bye3rc ' rc='rc
  call Bye
RETURN

OPENFILE:
  if length(mailfn)>13 then do
    if length(mailf)>13 then do
      if left(mailf,length(mailf)-13)\=left(mailfn,length(mailfn)-13) then mailf=mailfn /* else mailf=mailf */
      end
    else mailf=mailfn
    end
  else mailf=mailfile
  if pos('\',mailf)=0 then do
    if length(directory())>3 then mailf=directory()||'\'||mailf
    else mailf=directory()||mailf
    end
  if stream(mailf,'C','query exists')\='' then do
    if writeseparate=2 then call stream mailf,'C','seek <0 write'
    else do
      call Increment
      call stream mailf,'C','open write'
      end
    end
  else call stream mailf,'C','open write'
  if stream(mailf,'C','query exists')='' then do
    call Charout,'Bad '
    if mailfn='' then call Charout,'mailfile'
    else call Charout,'FILTER.'||a||' directory'
    say ' spec - Aborting'
    call Bye
    end
  of=1
RETURN

INCREMENT:
/* Template for incrementing to nonexistent 'mailfile' name(number) */
  dw=substr(mailf,length(mailf)-11,8)
  do until stream(mailf,'C','query exists')=''
    dw=dw+1
    mailf=left(mailf,length(mailf)-12)||right(dw,8,'0')||'.POP'
    end
RETURN

PREINCREMENT:
/* Increment to next 'mailfile' name(number) (when writeseparate=1) */
  dw=substr(mailf,length(mailf)-11,8)
  dw=dw+1
  mailf=left(mailf,length(mailf)-12)||right(dw,8,'0')||'.POP'
RETURN

FILTERS:
  a=0
  go=0
  do until a=g|go=1
    a=a+1
    wd=translate(left(filter.a,1))
    if verify(wd,'DW')>0 then leave
    if wd='D'&(writeauto=0) then nop
    else do
      filt=substr(filter.a,3)
      loc=translate(left(filt,pos('	',filt)-1))
      filt=substr(filt,pos('	',filt)+1)
      if wd='W' then strng=translate(left(filt,pos('	',filt)-1))
      else strng=translate(filt)
      strng2=strng
      if loc='NOTE'then do
        bye3rc='NOTEFILTERS'
        sd=''
        sd2=''
        remainder=''
        sz=-9999
        rc=SockSend(socket,'RETR '||y1||crlf)
        if rc>-1 then do
          do until sz<=0 /* Changed "=" to "<=" 10/3/01 */
            sc=SockRecv(socket,'sockdata',1024)
            if sz=-9999 then do
              parse var sockdata lin '0A'x dummy
              sz=siz.y1+length(lin)+4
              end
            sz=sz-sc
            sockdata=remainder||sockdata
            do until pos(lf,remainder)=0
              parse var sockdata lin '0A'x remainder
              if pos('.',lin)=1&lin\='.'||cr then do
                lin=substr(lin,2)
                sz=sz+1
                end
              ll=length(lin)
              if ll>0&pos(cr,lin)=ll then lin=left(lin,ll-1)
              if sd\=''then do
                if right(sd,1)\=' ' then sd=sd||' '
                end
              sd=sd||strip(translate(lin))
              sockdata=remainder
              end
            if sd2\=''&go=0 then do
              linuc.n=sd2||sd
              call FiltStrings
              end
            sd2=sd
            sd=''
            end
          if sd2\=''&go=0 then do
            linuc.n=sd2||sd
            sd=''
            sd2=''
            call FiltStrings
            end
          end
        else call Bye3
        end
      else do /* if loc\='NOTE' */
        if a=1 then do
          bye3rc='TOPFILTERS'
          remainder=''
          i=0
          rc=SockSend(socket,'TOP '||y1||' 0'||crlf)
          if rc>-1 then do until lin='.'
            rc=SockRecv(socket,'sockdata',1024)
            sockdata=remainder||sockdata
            do until pos(lf,remainder)=0
              parse var sockdata lin '0A'x remainder
              ll=length(lin)
              if ll>0&pos(cr,lin)=ll then lin=left(lin,ll-1)
              i=i+1
              linuc.i=strip(translate(lin))
              sockdata=remainder
              end
            end
          else call Bye3
          end
        do n=1 to i
          if go=0&pos(loc,linuc.n)=1 then call FiltStrings
          end
        end
      end
    end
RETURN

FILTSTRINGS:
  h=0;j=0
  if pos('\\',strng)>0 then do
    strng1=substr(strng,pos('\\',strng)+2)
    if pos(strng1,linuc.n)=0 then go=1
    end
  else do
    do while pos('&&',strng)>0
      h=h+1
      strng1=left(strng,pos('&&',strng)-1)
      if pos(strng1,linuc.n)>0 then j=j+1
      strng=substr(strng,pos('&&',strng)+2)
      end
    if h=j&pos(strng,linuc.n)>0 then go=1
    else do
      strng=strng2
      do while pos('||',strng)>0
        strng1=left(strng,pos('||',strng)-1)
        if pos(strng1,linuc.n)>0 then go=1
        strng=substr(strng,pos('||',strng)+2)
        end
      if pos(strng,linuc.n)>0 then go=1
      end
    end
  if go=1 then do
    if wd='W' then mailfn=strip(substr(filt,pos('	',filt)+1))||'\'||substr(date('S'),4)||'001.POP'
    if wd='D'&writeauto=1 then k='D'
    end
RETURN

CHECKDEL:
  do d1=0 to d
    if del.d1=dummy1 then do
      say
      say '  Message number 'dummy1' is DELETED'
      RETURN
      end
    end
RETURN

HALT:
  rc=SockSend(socket,'RSET'||crlf)  /* Unmark DELEtions */
  rc=SockRecv(socket,'sockdata',1024)
  call Bye2
RETURN

HELP:
  say
  say 'GetMail.CMD for [Runtime] Win32|OS/2 and [Object]Rexx'
  say '  XyShell R.J.Holmgren 30 December 2002		RFC 1939'
  say
  say 'Syntax:'
  say '[REXX.EXE] [d:\path\]GETMAIL.CMD ["d:\path\INIfile name"] ...'
  say ' [popserver username password] [-W[D]]'
  say ''
  say 'User Variables are not hard-coded in this program;'
  say '  they are supplied at Runtime, or in INI files [default=GetMail.INI]'
  say 'Command line [Runtime] arguments override INI file variables'
  say 'POPserver, Username, Password, and "-D[W]" arguments may be applied'
  say '  on-the-fly at Runtime (then GetMail operates in default mode:'
  say '  no separate files written and no filters)'
  say 'Runtime argument "-W" automatically Writes all msgs to "mailfile"'
  say '  (no reading) [same as: writeauto=1]'
  say 'Runtime argument "-WD" Deletes msgs on server after Writing to local'
  say '  "mailfile" [same as: writeauto=1 and deleteall=1]'
  say 'Locate INI files in the same directory as GetMail.CMD;'
  say '  establish separate INI files to process each Email account'
  say 'Enter User Variables in INI files using a plain-TEXT editor'
  say 'If no INI file exists, and command line args are used, GetMail.CMD will'
  say '  not write separate files or use filters; it will auto-write and/or'
  say '  auto-delete files only if command line "-W[D]" switch(es) are present'
  say 'Ctrl-C (if supported by OS and/or object "Properties") ReSETs POP server'
  say '  (DELEtions canceled), then aborts GetMail'
  say 'See GetMail.INI for more information'
  exit
RETURN

