/* XFF.CMD  XyFileFinder  R.J.Holmgren  20/8/2000 */

if RxFuncQuery("SysLoadFuncs") then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end
RexxDir=''
if pos('Window',SysVersion())=1 then do

/**USER**VARIABLE**FOR**WIN32**ONLY**
Rexx Installation Directory:
Default=[bootdrive:]\ObjREXX
         Set RexxDir on next line, e.g. RexxDir='C:\ObjREXX' */
RexxDir=SysBootDrive()||'\ObjREXX'
/************************************/

end
parse arg fspec
if length(fspec)>0&fspec\='?'&fspec\='/?'&fspec\='-?'&translate(fspec)\='HELP'&translate(fspec)\='/HELP'&translate(fspec)\='-HELP' then do
  wx=0
  say 'Searching for "'||fspec||'" specs...'
  call SysFileTree fspec,'file','BS'
  if file.0>0 then call SysCls
  say 'Number of "'||fspec||'" specs found:' file.0
  do i=1 to file.0
    a=file.i
    call Charout,a
    if RexxDir\='' then do
      if (pos('.',filespec("name",file.i))>9|pos(' ',filespec("name",file.i))>0)&pos(' -D--- ',a)=0 then do
        if wx=0 then do
          tmp=SysTempFileName(RexxDir||'\XFF_????.CMD')
          call stream tmp,'C','OPEN WRITE REPLACE'
          call charout tmp,'/* XFF_????.CMD */;a="";do while lines("STDIN")<>0;b=lineIn("STDIN");if a="" then do;a=substr(b,14,12);call Charout,a;end;end;exit;'
          call stream tmp,'C','CLOSE'
          wx=1
          end
        a=substr(file.i,36)
        a=strip(a)
        call Charout,' ['
        'ATTRIB "'||a||'"|'||RexxDir||'\REXX.EXE '||tmp
        call Charout,']'
        end
      end
    say
    x=SysCurPos()
    if left(x,pos(' ',x)-1)>=23 then do
      call Charout,'Hit any key to continue...'
      pull x
      call SysCls
      end
    end
  if file.0>0 then do
    if wx=1 then call SysFileDelete tmp
    call Charout,'Hit any key to quit...'
    pull x
    end
  say
  end
else do
  say 'XFF.CMD for Win32 and OS/2  XyFileFinder  R.J.Holmgren  20/8/2000'
  say 'Recursive search for files and [sub]directories'
  say 'DOS "8.3" filenames also reported for LongFileNames'
  say 'Requires XFF_.CMD also; all files installed in BootDrive:\ObjREXX'
  say
  say 'Usages:  XFF file|dir_spec<Helpkey>     <==XyWrite'
  say '~~~~~~   XFF[.BAT] file|dir_spec<cr>    <==DOS'
  say '         REXX XFF.CMD file|dir_spec<cr> <==DOS'
  say '  e.g.:  xff C:\*.IN?'
  end
exit
